/*
 * IV Mistrzostwa Wielkopolski w Programowaniu Zespolowym
 * Poznan, 1-2.XII.2005
 *
 * Program wzorcowy do zadania B - Przedziay
 *
 * Autor programu: Wojciech Mruczkiewicz
 */

#include <algorithm>
#include <cstdio>
#include <ctype.h>
using namespace std;

#define MAX_R 40002
#define R_OFF 20000
#define N_MAX 20000
#define EAT(a) while (isspace(ch = getchar()));

int R[MAX_R];


int parsel() {
	char ch, lb;
	bool ln = false;
	bool zl = true;
	int l = 0;

	EAT(ch);
	lb = ch;
	EAT(ch);

	if (ch == '-') {
		ln = true;
		ch = getchar();
	}

	for (; ch != ','; ch = getchar()) {
		l *= 10;
		l += ch - '0';
	}

	for (ch = getchar(); isdigit(ch); ch = getchar())
		if (ch != '0')
			zl = false;

	if (ln) {
		l *= -1;
		if (lb == '(' && zl)
			l++;
	} else {
		l++;
		if (lb == '[' && zl)
			l--;
	}
	return min(N_MAX + 1, max(-N_MAX, l));
}

int parser() {
	char ch, rb;
	bool rn = false;
	bool zr = true;
	int r = 0;

	EAT(ch);
	getchar();
	EAT(ch);

	if (ch == '-') {
		rn = true;
		ch = getchar();
	}

	for (; ch != ','; ch = getchar()) {
		r *= 10;
		r += ch - '0';
	}

	for (ch = getchar(); isdigit(ch); ch = getchar())
		if (ch != '0')
			zr = false;

	EAT(ch);
	rb = ch;

	if (rn) {
		r *= -1;
		r--;
		if (rb == ']' && zr)
			r++;
	} else {
		if (rb == ')' && zr)
			r--;
	}

	return min(N_MAX, max(-N_MAX - 1, r));
}

int main() {
	int t;
	scanf("%d", &t);

	while (t--) {
		int n, sum = 0, in = 0;

		scanf("%d", &n);

		for (int i = 0; i < MAX_R; i++)
			R[i] = 0;
		
		for (int i = 0; i < n; i++) {
			int l = max(-R_OFF, parsel());
			int r = min(R_OFF, parser());

			R[l + R_OFF]++;
			R[r + R_OFF + 1]--;
		}

		for (int i = 0, x = 0; i < MAX_R; i++) {
			x += R[i];

			if (x == n)
				in++;

			if (x)
				sum++;
		}
		printf("%d\n%d\n", sum, in);
	}
	return 0;
}

