{*
 * IV Mistrzostwa Wielkopolski w Programowaniu Zespolowym
 * Poznan, 1-2.XII.2005
 *
 * Program wzorcowy do zadania C - Autobus
 *
 * Autor programu: Piotr Gawron
 *}

program autobus;
const MAX_N = 20000;
const MAX_D = 50;
type
    str= record
	pocz: longint;
	rozm: longint;
    end;
var
    kopiec: array[1..MAX_N] of str;
    rozmiar:longint;
    t:array[1..MAX_N] of longint;
    t1:array[1..MAX_N] of longint;
    
function wiekszy(a,b:str):boolean;
begin
    if ((a.rozm+1) div 2 = (b.rozm+1) div 2) then
	wiekszy := a.pocz < b.pocz
    else
	wiekszy := a.rozm > b.rozm;
end;
procedure wstaw(a: str);
var
    i:longint;
    b:str;
begin
    assert(rozmiar<MAX_N);
    inc(rozmiar);
    kopiec[rozmiar]:=a;
    i:=rozmiar;
    while(i>1) do begin
	if (wiekszy(kopiec[i],kopiec[i div 2])) then begin
	    b:=kopiec[i];
	    kopiec[i]:=kopiec[i div 2];
	    kopiec[i div 2]:=b;
	    i:=i div 2;
	end else begin
	    break;
	end;
    end;
end;

function pobierz():str;
var
    b:str;
    i:longint;
begin
    assert(rozmiar>0);
    pobierz:=kopiec[1];
    kopiec[1]:=kopiec[rozmiar];
    dec(rozmiar);
    i:=1;
    while (i*2<=rozmiar) do begin
	if (wiekszy(kopiec[i*2],kopiec[i]) or wiekszy(kopiec[i*2+1],kopiec[i])) then begin
	    if (i*2+1>rozmiar) then begin {jezeli zrzucamy na koniec kopca to trzeba pamietac by nie brac pod uwage elementu poza kopcem}
		b:=kopiec[i];
		kopiec[i]:=kopiec[i*2];
		kopiec[i*2]:=b;
		i:=i*2;
	    end else if (wiekszy(kopiec[i*2],kopiec[i*2+1])) then begin
		b:=kopiec[i];
		kopiec[i]:=kopiec[i*2];
		kopiec[i*2]:=b;
		i:=i*2;
	    end else begin
		b:=kopiec[i];
		kopiec[i]:=kopiec[i*2+1];
		kopiec[i*2+1]:=b;
	    
		i:=i*2+1;
	    end;
	end else begin
	    break;
	end;
    end;
end;
var
    a,b: str;
    d,m,n,x,y,i,j,k,NR:longint;

procedure dodaj(a:str);
begin
    if ((a.rozm>0) and (a.pocz+((a.rozm-1) div 2)>0) and (a.pocz + ((a.rozm - 1) div 2) <= n)) then
	wstaw(a);
end;

begin
    read(d);
    readln;
    assert((d>=1) and (d<=MAX_D));
    for k:=1 to d do begin
	read(n,m,x,y);
	readln;
	assert((n>=1) and (n<=MAX_N));
	assert((m>=1) and (m<=n));
	assert((x>=1) and (x<=n));
	assert((y>=1) and (y<=m));
	for j:=1 to y do begin
	    read(t[j]);
	    assert((t[j]>=1) and (t[j]<=m));
	    if (j>1) then
		assert(t[j]>t[j-1]);
	end;
	NR:=1;
	t1[NR]:=x;
	inc(NR);
	if x>1 then begin
	    a.rozm:=(x-1)*2-1;
	    a.pocz:=-x+3;
	    dodaj(a);
	end;
	if x<n then begin
	    a.rozm:=(n-x-1)*2+1;
	    a.pocz:=x+1;
	    dodaj(a);
	end;
	while(rozmiar>0) do begin
	    a:=pobierz;
	    i:=(a.rozm-1) div 2 + 1;
	    t1[NR]:=a.pocz-1+i;
	    inc(NR);
	    b.pocz:=a.pocz;
	    b.rozm:=i-1;
	    dodaj(b);
	    b.rozm:=a.rozm-i;
	    b.pocz:=a.pocz+i;
	    dodaj(b);
	end;
	for i:=1 to y do 
	    write(t1[t[i]],' ');
	writeln;
    end;
    rozmiar:=0;
end.
