{*
 * IV Mistrzostwa Wielkopolski w Programowaniu Zespolowym
 * Poznan, 1-2.XII.2005
 *
 * Program wzorcowy do zadania G - Billboardy
 *
 * Autor programu: Piotr Gawron
 *}

program billboardy;
const MAX_D = 50;
const MAX_N = 1000;
const MAX_M = 1000000;
const MAX_X = 100;
const MAX_Di = 1000;
var
    T:array[1..MAX_N] of longint;
    T1:array[1..MAX_N,1..MAX_N] of longint;
    T2:array[1..MAX_N] of longint;
procedure dfs(x: longint; y:longint);
var
    i:longint;
begin
    if (T2[x]>=0) then 
	exit;
    T2[x]:=y;
    for i:=1 to MAX_N do 
        if (T1[x,i]=1) then
    	    dfs(i,1-y);
end;
var
    a,b,c,d,i,j,k,n,m,max:longint;
begin
    d:=-1;
    readln(d);
    assert((d>=1) and (d<=MAX_D));
    for i:=1 to d do begin
	n:=-1;
	m:=-1;
	readln(n,m);
	assert((n>=1) and (n<=MAX_N));
	assert((m>=0) and (m<=MAX_M));
	max:=0;
	for j:=1 to n do begin
	    T[j]:=-1;
	    readln(T[j]);
	    assert((T[j]>=0) and (T[j]<=MAX_X));
	    if (T[j]>max) then
		max:=T[j];
	    T2[j]:=-1;
	end;
	for j:=1 to n do
	    for k:=1 to n do
		T1[j,k]:=0;
	for j:=1 to m do begin
	    a:=-1;
	    b:=-1;
	    c:=-1;
	    readln(a,b,c);
	    assert((1<=a) and (a<=n));
	    assert((1<=b) and (b<=n));
	    assert((1<=c) and (c<=MAX_Di));
	    T1[a,b]:=1;
	    T1[b,a]:=1;
	    if max<T[a]+T[b] then
		max:=T[a]+T[b];
	end;
	writeln(max);
	for j:=1 to n do begin
	    if T2[j]<0 then
		dfs(j,1);
	    if T2[j]=0 then begin
		for k:=1 to T[j] do
		    write(k,' ');
		writeln;
	    end else begin
		for k:=1 to T[j] do
		    write(max-k+1,' ');
		writeln;
	    end;
	end;
    end;
end.
