/*
 * IV Mistrzostwa Wielkopolski w Programowaniu Zespolowym
 * Poznan, 1-2.XII.2005
 *
 * Program wzorcowy do zadania G - Billboardy
 *
 * Autor programu: Wojciech Mruczkiewicz
 */

#include <cstdio>
#include <algorithm>
#include <vector>
using namespace std;

#define MAX_N 1000

vector<int> G[MAX_N];
bool C[MAX_N];
int V[MAX_N];
int X[MAX_N];
int n, m, c;

void dfs(int x, bool color);

int main()
{
        int d;

        scanf("%d", &d);

        while (d--) {
                scanf("%d%d", &n, &m);

                c = 0;

                for (int i = 0; i < n; i++) {
                        V[i] = 0;
                        G[i].clear();
                }

                for (int i = 0; i < n; i++) {
                        scanf("%d", &X[i]);
                        c = max(c, X[i]);
                }

                for (int i = 0; i < m; i++) {
                        int a, b, z;
                        scanf("%d%d%d", &a, &b, &z);

                        --a; --b;

                        c = max(c, X[a] + X[b]);
                        G[a].push_back(b);
                        G[b].push_back(a);
                }

                printf("%d\n", c);

                for (int i = 0; i < n; i++) {
                        if (!V[i])
                                dfs(i, 0);

                        if (C[i]) {
                                for (int j = 0; j < X[i]; j++) {
                                        if (j)
                                                printf(" ");
                                        printf("%d", j + 1);
                                }
                        } else {
                                for (int j = 0; j < X[i]; j++) {
                                        if (j)
                                                printf(" ");
                                        printf("%d", c - j);
                                }
                        }
                        printf("\n");
                }
        }

        return 0;
}

void dfs(int x, bool color)
{
        V[x] = 1;
        C[x] = color;

       // printf("%d %d\n", x, C[x]);

        for (int i = 0; i < G[x].size(); i++)
                if (!V[G[x][i]])
                        dfs(G[x][i], !color);
}


