/*
 * IV Mistrzostwa Wielkopolski w Programowaniu Zespolowym
 * Poznan, 1-2.XII.2005
 *
 * Program wzorcowy do zadania H - Konkurs
 * Zoono czasowa - O(n^2)
 *
 * Autor programu: Wojciech Mruczkiewicz
 */

#include <algorithm>
#include <cstdio>
using namespace std;

#define MAX_N 500

int A[MAX_N];

int main() {
	int t;
	scanf("%d", &t);
	while (t--) {
		int n, i, j;
		scanf("%d", &n);

		for (int i = 0; i < n; i++)
			scanf("%d", &A[i]);
		
		for (int i = 0; i < n; i++) {
			int mi = i;
			for (int j = i + 1; j < n; j++)
				if (A[mi] > A[j])
					mi = j;
			swap(A[i], A[mi]);
		}

		printf("%d", A[n-1]);

		for (i = n-2; i >= 0 && A[i] == A[i+1]; i--)
			printf(" %d", A[i]);

		for (j = 0; j <= i; j++)
			printf(" %d", A[j]);
		printf("\n");
	}
	return 0;
}

